﻿Imports System.Runtime.InteropServices

Public Class Form1


	Private Const WS_CHILD As Integer = &H40000000
	Private Const WS_VISIBLE As Integer = &H10000000

	Private Const WM_USER As Integer = &H400
	Private Const WM_CAP_START As Integer = WM_USER
	Private Const WM_CAP_DRIVER_CONNECT As Integer = (WM_CAP_START + 10)
	Private Const WM_CAP_DRIVER_DISCONNECT As Integer = (WM_CAP_START + 11)
	Private Const WM_CAP_DRIVER_GET_CAPS As Integer = (WM_CAP_START + 14)

	Private Const WM_CAP_SET_PREVIEW As Integer = (WM_CAP_START + 50)
	Private Const WM_CAP_SET_OVERLAY As Integer = (WM_CAP_START + 51)
	Private Const WM_CAP_SET_PREVIEWRATE As Integer = (WM_CAP_START + 52)

	Private Const WM_CAP_DLG_VIDEOFORMAT As Integer = (WM_CAP_START + 41)
	Private Const WM_CAP_DLG_VIDEOSOURCE As Integer = (WM_CAP_START + 42)
	Private Const WM_CAP_DLG_VIDEODISPLAY As Integer = (WM_CAP_START + 43)
	Private Const WM_CAP_GET_VIDEOFORMAT As Integer = (WM_CAP_START + 44)
	Private Const WM_CAP_SET_VIDEOFORMAT As Integer = (WM_CAP_START + 45)
	Private Const WM_CAP_DLG_VIDEOCOMPRESSION As Integer = (WM_CAP_START + 46)

	Private Declare Function SendMessage Lib "User32" Alias "SendMessageA" (ByVal hWnd As IntPtr,
																			ByVal Msg As Integer,
																			ByVal wParam As IntPtr,
																			ByVal lParam As IntPtr) As Integer

	'Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
	'	(ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer,
	'	<MarshalAs(UnmanagedType.AsAny)> ByVal lParam As Object) As Integer


	Private Declare Function capCreateCaptureWindowA Lib "Avicap32" (ByVal lpszWindowName As String,
													ByVal dwStyle As Integer,
													ByVal x As Integer,
													ByVal y As Integer,
													ByVal nWidth As Integer,
													ByVal nHeight As Integer,
													 ByVal hwndParent As IntPtr,
													ByVal nId As Integer) As IntPtr

	Private Function capDriverConnect(ByVal hwnd As IntPtr, ByVal iIndex As Integer) As Boolean
		capDriverConnect = CBool(SendMessage(hwnd, WM_CAP_DRIVER_CONNECT, iIndex, 0))
	End Function

	Private Declare Auto Function SendCapDriverCapsMessage Lib "user32.dll" Alias "SendMessageA" (
			   ByVal hWnd As IntPtr,
			   ByVal msg As Integer,
			   ByVal wParam As IntPtr,
			   ByRef lParam As CapDriverCaps) As Integer
	Private Function capDriverGetCaps(ByVal hwnd As IntPtr, ByRef caps As CapDriverCaps, wSize As Integer) As Boolean

		'		capDriverGetCaps = CBool(SendMessage(hwnd, WM_CAP_DRIVER_GET_CAPS, wSize, caps))
		capDriverGetCaps = CBool(SendCapDriverCapsMessage(hwnd, WM_CAP_DRIVER_GET_CAPS, wSize, caps))

	End Function

	Private Structure CapDriverCaps
		Dim wDeviceIndex As Integer
		Dim fHasOverlay As Boolean
		Dim fHasDlgVideoSource As Boolean
		Dim fHasDlgVideoFormat As Boolean
		Dim fHasDlgVideoDisplay As Boolean
		Dim fCaptureInitialized As Boolean
		Dim fDriverSuppliesPalettes As Boolean
		Dim hVideoIn As IntPtr
		Dim hVideoOut As IntPtr
		Dim hVideoExtIn As IntPtr
		Dim hVideoExtOut As IntPtr
	End Structure

	Private m_CaptureWindowHandle As IntPtr


	Private Sub DisconnectVideo()
		If m_CaptureWindowHandle <> IntPtr.Zero Then
			SendMessage(m_CaptureWindowHandle, WM_CAP_DRIVER_DISCONNECT, 0, 0)
		End If
	End Sub
	Private Sub btnDisconnect_Click(sender As Object, e As EventArgs) Handles btnDisconnect.Click
		DisconnectVideo()
	End Sub

	Private Sub btnConnect_Click(sender As Object, e As EventArgs) Handles btnConnect.Click
		Dim nId As Integer

		If m_CaptureWindowHandle <> IntPtr.Zero Then
			DisconnectVideo()
		End If

		m_CaptureWindowHandle = capCreateCaptureWindowA("Capture Window", WS_CHILD Or WS_VISIBLE,
													10, 10, 640, 360, CType(Me, IWin32Window).Handle, nId)

		If m_CaptureWindowHandle <> IntPtr.Zero Then
			Dim apiResult As Boolean
			apiResult = capDriverConnect(m_CaptureWindowHandle, 0)

			apiResult = SendMessage(m_CaptureWindowHandle, WM_CAP_SET_PREVIEWRATE, 500, 0)

			apiResult = SendMessage(m_CaptureWindowHandle, WM_CAP_SET_PREVIEW, 1, 0)

			Dim driverCaps As CapDriverCaps
			Dim capSize As Integer = Marshal.SizeOf(driverCaps)

			apiResult = capDriverGetCaps(m_CaptureWindowHandle, driverCaps, capSize)

			If apiResult Then
				Me.btnDisplayProperties.Enabled = driverCaps.fHasDlgVideoDisplay
				Me.btnFormatProperties.Enabled = driverCaps.fHasDlgVideoFormat
				Me.btnSourceProperties.Enabled = driverCaps.fHasDlgVideoSource
			End If
			Me.btnDisconnect.Enabled = True
		Else
			MessageBox.Show("CreateCaptureWindow failed")
		End If

	End Sub

	Private Sub btnShowProperties_Click(sender As Object, e As EventArgs) Handles btnSourceProperties.Click
		SendMessage(m_CaptureWindowHandle, WM_CAP_DLG_VIDEOSOURCE, 0, 0)
	End Sub

	Private Sub btnFormatProperties_Click(sender As Object, e As EventArgs) Handles btnFormatProperties.Click
		SendMessage(m_CaptureWindowHandle, WM_CAP_DLG_VIDEOFORMAT, 0, 0)
	End Sub

	Private Sub btnDisplayProperties_Click(sender As Object, e As EventArgs) Handles btnDisplayProperties.Click
		SendMessage(m_CaptureWindowHandle, WM_CAP_DLG_VIDEODISPLAY, 0, 0)
	End Sub

	Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
		DisconnectVideo()
	End Sub

End Class
